#include "testApp.h"


static bool bRecording = false;



//--------------------------------------------------------------
void testApp::setup(){

	camWidth 		= 320;	// try to grab at this size. 
	camHeight 		= 240;
	
	vidGrabber.setVerbose(true);
	vidGrabber.initGrabber(camWidth,camHeight);
	
	saver.listCodecs();
	//saver.setCodecType(2); ZACH FIX see recording quicktime with sound in sync on of forum
	saver.setCodecQualityLevel(OF_QT_SAVER_CODEC_QUALITY_NORMAL);
	saver.setup(320,240,"output.mov");
	
	ofSetFrameRate(30);
	
}

//--------------------------------------------------------------
void testApp::update(){

	ofBackground(100,100,100);
	
	vidGrabber.grabFrame();
	
	
	if (bRecording == true){
		saver.addFrame(vidGrabber.getPixels(), 1.0f / 30.0f); 
		
		//  you can also pass in the frameRate:
		//	saver.addFrame(vidGrabber.getPixels(), 1.0f / 30.0f);  // 30 fps for this frame
		//	saver.addFrame(vidGrabber.getPixels(), 1.0f / 5.0f);   // 5 fps for this frame, etc....
		
	}
	
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetColor(0xffffff);
	vidGrabber.draw(20,20);
	
	if (saver.bAmSetupForRecording()){
		ofSetColor(0xffffff);
		ofDrawBitmapString("setup for recording, (press 's' to save)",100,300);
		
		if (bRecording){
			ofSetColor(0x00ff00);
			ofDrawBitmapString("recording, (press 'r' to toggle)",100,320);
		} else {
			ofSetColor(0xff0000);
			ofDrawBitmapString("not recording, (press 'r' to toggle)",100,320);
		}
	} else {
		ofSetColor(0xffffff);
		ofDrawBitmapString("not setup for recording (press 'a' to start)",100,300);
		ofSetColor(0xaaaaaa);
		ofDrawBitmapString("not setup to record",100,320);
	}
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	if (key == 'a'){
		saver.setup(320,240,"output.mov");
	} else if (key == 's'){
		saver.finishMovie();
		bRecording = false;
	} else if (key == 'r'){
		bRecording = !bRecording;
	}
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

